package clustering.poboc;

import java.sql.SQLException;
import java.util.ArrayList;

import clustering.helpers.OverlappingClustersResultFetcher;
import clustering.poboc.sql.ClustersTable;

public class PoBOCResultFetcher implements OverlappingClustersResultFetcher {

	private final ClustersTable table;
	private String[] clusters;
	
	public PoBOCResultFetcher(ClustersTable table) {
		this.table = table;
	}
	
	@Override
	public String[] getClusters() {
		if(clusters == null) {
			try {
				int[] clustersId = table.getClusters();
				ArrayList<String> list = new ArrayList<String>();
				for(int id : clustersId) {
					list.add("c"+id);
				}
				clusters = list.toArray(new String[0]);
			} catch (SQLException e) {
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}
		return clusters;
	}

	@Override
	public boolean[] getClustersArray(int rowId) {
		boolean[] result = new boolean[getClusters().length];
		try {
			int[] clustersId = table.getClusters(rowId);
			for(int i=0; i < result.length; i++) {
				for(int k=0; k < clustersId.length; k++) {
					if(clustersId[k] == i) {
						result[i] = true;
						break;
					}
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
		return result;
	}

}
